Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# ACE_Asynch_Write_Dgram Class Reference

This class is a factory for starting off asynchronous writes on a UDP socket. This class forwards all methods to its implementation class. More...

`#include <Asynch_IO.h>`

Inheritance diagram for ACE_Asynch_Write_Dgram:

[legend]
Collaboration diagram for ACE_Asynch_Write_Dgram:

[legend]
List of all members.

## Public Methods
| ACE_Asynch_Write_Dgram (void)
| A do nothing constructor.
virtual | ~ACE_Asynch_Write_Dgram (void)
| Destructor.
int | open (ACE_Handler &handler, ACE_HANDLE handle=ACE_INVALID_HANDLE, const void *completion_key=0, ACE_Proactor *proactor=0)
ssize_t | send (ACE_Message_Block *message_block, size_t &number_of_bytes_sent, int flags, const ACE_Addr &remote_addr, const void *act=0, int priority=0, int signal_number=ACE_SIGRTMIN)
ACE_Asynch_Write_Dgram_Impl * | implementation (void) const
| Return the underlying implementation class.
## Protected Methods
void | implementation (ACE_Asynch_Write_Dgram_Impl *implementation)
| Set the implementation class.
## Protected Attributes
ACE_Asynch_Write_Dgram_Impl * | implementation_
| Implementation class that all methods will be forwarded to.

## Detailed Description

This class is a factory for starting off asynchronous writes on a UDP socket. This class forwards all methods to its implementation class.

Once <open> is called, multiple asynchronous <writes>s can started using this class. An ACE_Asynch_Write_Dgram::Result will be passed back to the <handler> when the asynchronous write completes through the <ACE_Handler::handle_write_dgram> callback.

## Constructor & Destructor Documentation

ACE_Asynch_Write_Dgram::ACE_Asynch_Write_Dgram | ( | void |  | ) |

| A do nothing constructor.

ACE_Asynch_Write_Dgram::~ACE_Asynch_Write_Dgram | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

void ACE_Asynch_Write_Dgram::implementation | ( | ACE_Asynch_Write_Dgram_Impl * | implementation | ) | `[protected]`

| Set the implementation class.

ACE_Asynch_Write_Dgram_Impl * ACE_Asynch_Write_Dgram::implementation | ( | void |  | ) | const

| Return the underlying implementation class. Reimplemented from ACE_Asynch_Operation.

int ACE_Asynch_Write_Dgram::open | ( | ACE_Handler & | handler,
|  | ACE_HANDLE | handle = ACE_INVALID_HANDLE,
|  | const void * | completion_key = 0,
|  | ACE_Proactor * | proactor = 0
| ) |

| Initializes the factory with information which will be used with each asynchronous call. If (<handle> == ACE_INVALID_HANDLE), <ACE_Handler::handle> will be called on the <handler> to get the correct handle. Reimplemented from ACE_Asynch_Operation.

ssize_t ACE_Asynch_Write_Dgram::send | ( | ACE_Message_Block * | message_block,
|  | size_t & | number_of_bytes_sent,
|  | int | flags,
|  | const ACE_Addr & | remote_addr,
|  | const void * | act = 0,
|  | int | priority = 0,
|  | int | signal_number = ACE_SIGRTMIN
| ) |

| This starts off an asynchronous send. Upto <message_block->total_length()> will be sent. <message_block>'s <rd_ptr> will be updated to reflect the sent bytes if the send operation is successfully completed. Return code of 1 means immediate success and <number_of_bytes_sent> is updated to number of bytes sent. The <ACE_Handler::handle_write_dgram> method will still be called. Return code of 0 means the IO will complete proactively. Return code of -1 means there was an error, use errno to get the error code. Scatter/gather is supported on WIN32 by using the <message_block->cont()> method. Up to ACE_IOV_MAX <message_block>'s are supported. Upto <message_block->length()> bytes will be sent from each <message block> for a total of <message_block->total_length()> bytes. All <message_block>'s <rd_ptr>'s will be updated to reflect the bytes sent from each <message_block>. Priority of the operation is specified by <priority>. On POSIX4-Unix, this is supported. Works like <nice> in Unix. Negative values are not allowed. 0 means priority of the operation same as the process priority. 1 means priority of the operation is one less than process. And so forth. On Win32, this argument is a no-op. <signal_number> is the POSIX4 real-time signal number to be used for the operation. <signal_number> ranges from ACE_SIGRTMIN to ACE_SIGRTMAX. This argument is a no-op on non-POSIX4 systems.

## Member Data Documentation

ACE_Asynch_Write_Dgram_Impl* ACE_Asynch_Write_Dgram::implementation_`[protected]`

| Implementation class that all methods will be forwarded to. Reimplemented from ACE_Asynch_Operation.

The documentation for this class was generated from the following files:

- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Asynch_IO.h
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Asynch_IO.cpp